---
title: 'ARIA: tab role'
slug: Web/Accessibility/ARIA/Roles/Tab_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA Tab
  - ARIA widget
  - Reference
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p><span class="seoSummary">The ARIA <code>tab</code> role indicates an interactive element inside a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Tablist_Role">tablist</a> that, when activated, displays its associated <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Tabpanel_Role">tabpanel</a>.</span></p>

<pre class="brush: html notranslate">&lt;button role="tab" aria-selected="true" aria-controls="tabpanel-id" id="tab-id"&gt;Tab label&lt;/button&gt;</pre>

<h2 id="Description">Description</h2>

<p>An element with the <code>tab</code> role controls the visibility of an associated element with the <code>tabpanel</code> role. The common user experience pattern is a group of visual tabs above, or to the side of, a content area, and selecting a different tab changes the content and makes the selected tab more prominent than the other tabs.</p>

<p>Elements with the role <code>tab</code> <em>must</em> either be a child of an element with the <code>tablist</code> role, or have their <code>id</code> part of the <code>aria-owns</code> property of a <code>tablist</code>. This combination identifies to assistive technology that the element is part of a group of related elements. Some assistive technology will provide a count of the number of <code>tab</code> role elements inside a <code>tablist</code>, and inform users of which <code>tab</code> they currently have targeted. They <em>should</em> contain the <code>aria-controls</code> property identifying an element with the <code>tabpanel</code> role. When an element with the <code>tabpanel</code> role has focus, or a child of it has focus, that indicates that the connected element with the <code>tab</code> role is the active tab in a <code>tablist</code>.</p>

<p>When working with elements with the <code>tab</code> role, when they are selected or active, they should have their <code>aria-selected</code> attribute set to <code>true</code>, otherwise it should be set to <code>false</code>. When a <code>tab</code> is selected or active, its controlled <code>tabpanel</code> should have its <code>aria-expanded</code> attribute set to true and its <code>hidden</code> attribute set to <code>false</code>, otherwise the reverse.</p>

<h3 id="Associated_Roles_and_Attributes">Associated Roles and Attributes</h3>

<dl>
	<dt>aria-selected</dt>
	<dd>boolean</dd>
	<dt>aria-controls</dt>
	<dd><code>id</code> of element with <code>tabpanel</code> role</dd>
	<dt>id</dt>
	<dd>content</dd>
</dl>

<h3 id="Keyboard_interaction">Keyboard interaction</h3>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Key</th>
			<th scope="col">Action</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><kbd>Tab</kbd></td>
			<td>When focus is outside of the <code>tablist</code> moves focus to the active tab. If focus is on the active tab moves focus to the next element in the keyboard focus order, ideally the active tab's associated <code>tabpanel</code>.</td>
		</tr>
		<tr>
			<td><kbd>→</kbd></td>
			<td>Focuses and optionally activates the next tab in the tab list. If the current tab is the last tab in the tab list it activates the first tab.</td>
		</tr>
		<tr>
			<td><kbd>←</kbd></td>
			<td>Focuses and optionally activates the previous tab in the tab list. If the current tab is the first tab in the tab list it activates the last tab.</td>
		</tr>
		<tr>
			<td><kbd>Delete</kbd></td>
			<td>When allowed removes the currently selected tab from the tab list.</td>
		</tr>
	</tbody>
</table>

<h3 id="Required_JavaScript_features">Required JavaScript features </h3>

<div class="note">
<p>While there are ways to build tab-like functionality without JavaScript, there are no substitute combination of HTML and CSS only that will provide the same set of functionality that's required above for accessible tabs with content.</p>
</div>

<h2 id="Example">Example</h2>

<p>This example combines the role <code>tab</code> with <code>tablist</code> and elements with <code>tabpanel</code> to create an interactive group of tabbed content. Here we are enclosing our group of content in a <code>div</code>, with our <code>tablist</code> having an <code>aria-label</code> to label it for assistive technology. Each <code>tab</code> is a <code>button</code> with the attributes previously mentioned. The first <code>tab</code> has <code>tabindex=0</code> on it, which we will later change to whatever tab has <code>aria-selected=true</code>. All of the <code>tabpanel</code> elements have <code>tabindex=0</code> to make them tabbable, and all but the currently active one have the <code>hidden</code> attribute, which we will change with JavaScript. There is some basic styling applied that restyles the buttons and changes the <code><a href="/en-US/docs/Web/CSS/z-index">z-index</a></code> to of <code>tab</code> elements to give the illusion of it connecting to the <code>tabpanel</code> for active elements, and the illusion that inactive elements are behind the active <code>tabpanel</code>.</p>

<pre class="brush: html notranslate">&lt;div class="tabs"&gt;
  &lt;div role="tablist" aria-label="Sample Tabs"&gt;
    &lt;button role="tab" aria-selected="true" aria-controls="panel-1" id="tab-1" tabindex="0"&gt;
          First Tab
        &lt;/button&gt;
    &lt;button role="tab" aria-selected="false" aria-controls="panel-2" id="tab-2" tabindex="-1"&gt;
          Second Tab
        &lt;/button&gt;
    &lt;button role="tab" aria-selected="false" aria-controls="panel-3" id="tab-3" tabindex="-1"&gt;
          Third Tab
        &lt;/button&gt;
  &lt;/div&gt;
  &lt;div id="panel-1" role="tabpanel" tabindex="0" aria-labelledby="tab-1"&gt;
    &lt;p&gt;Content for the first panel&lt;/p&gt;
  &lt;/div&gt;
  &lt;div id="panel-2" role="tabpanel" tabindex="0" aria-labelledby="tab-2" hidden&gt;
    &lt;p&gt;Content for the second panel&lt;/p&gt;
  &lt;/div&gt;
  &lt;div id="panel-3" role="tabpanel" tabindex="0" aria-labelledby="tab-3" hidden&gt;
    &lt;p&gt;Content for the third panel&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt;</pre>

<div class="hidden">
<pre class="brush: css notranslate">.tabs {
  padding: 1em;
}

[role="tablist"] {
  margin-bottom: -1px;
}

[role="tab"] {
  position: relative;
  z-index: 1;
  background: white;
  border-radius: 5px 5px 0 0;
  border: 1px solid grey;
  border-bottom: 0;
  padding: 0.2em;
}

[role="tab"][aria-selected="true"] {
  z-index: 3;
}

[role="tabpanel"] {
  position: relative;
  padding: 0 0.5em 0.5em 0.7em;
  border: 1px solid grey;
  border-radius: 0 0 5px 5px;
  background: white;
  z-index: 2;
}

[role="tabpanel"]:focus {
  border-color: orange;
  outline: 1px solid orange;
}</pre>
</div>

<p>There are two things we need to do with JavaScript: we need to change focus and tab index of our <code>tab</code> elements with the right and left arrows, and we need to change the active <code>tab</code> and <code>tabpanel</code> when we click on a <code>tab</code>.</p>

<p>To accomplish the first, we listen for the <code><a href="/en-US/docs/Web/API/Element/keydown_event">keydown</a></code> event on the <code>tablist</code>. If the event's <code><a href="/en-US/docs/Web/API/KeyboardEvent/keyCode">keyCode</a></code> is 39 for right arrow or 37 for the left arrow, we react to the event. We start by setting the <code>tabindex</code> of the current <code>tab</code> element to -1, making it no longer tabbable. Then, if the right arrow is being pressed, we increase our tab focus counter by one. If the counter is greater than the number of <code>tab</code> elements we have, we circle back to the first tab by setting that counter to 0. If the left arrow is being pressed, we decrease our tab focus counter by one, and if it is then less than 0, we set it number of <code>tab</code> elements minus one (to get to the last element). Finally, we set focus to the <code>tab</code> element whose index is equal to the tab focus counter, and set its <code>tabindex</code> to 0 to make it tabbable.</p>

<p>To handle changing the active <code>tab</code> and <code>tabpanel</code>, we have a function that takes in the event, gets the element that triggered the event, the triggering element's parent element, and its grandparent element. We then find all tabs with <code>aria-selected=true</code> inside the parent element and sets it to <code>false</code>, then sets the triggering element's <code>aria-selected</code> to <code>true</code>. After that, we find all <code>tabpanel</code> elements in the grandparent element, make them all <code>hidden</code>, and finally select the element whose <code>id</code> is equal to the triggering <code>tab</code>'s <code>aria-controls</code> and removes the <code>hidden</code> attribute, making it visible.</p>

<pre class="brush: js notranslate">window.addEventListener("DOMContentLoaded", () =&gt; {
  const tabs = document.querySelectorAll('[role="tab"]');
  const tabList = document.querySelector('[role="tablist"]');

  // Add a click event handler to each tab
  tabs.forEach(tab =&gt; {
    tab.addEventListener("click", changeTabs);
  });

  // Enable arrow navigation between tabs in the tab list
  let tabFocus = 0;

  tabList.addEventListener("keydown", e =&gt; {
    // Move right
    if (e.keyCode === 39 || e.keyCode === 37) {
      tabs[tabFocus].setAttribute("tabindex", -1);
      if (e.keyCode === 39) {
        tabFocus++;
        // If we're at the end, go to the start
        if (tabFocus &gt;= tabs.length) {
          tabFocus = 0;
        }
        // Move left
      } else if (e.keyCode === 37) {
        tabFocus--;
        // If we're at the start, move to the end
        if (tabFocus &lt; 0) {
          tabFocus = tabs.length - 1;
        }
      }

      tabs[tabFocus].setAttribute("tabindex", 0);
      tabs[tabFocus].focus();
    }
  });
});

function changeTabs(e) {
  const target = e.target;
  const parent = target.parentNode;
  const grandparent = parent.parentNode;

  // Remove all current selected tabs
  parent
    .querySelectorAll('[aria-selected="true"]')
    .forEach(t =&gt; t.setAttribute("aria-selected", false));

  // Set this tab as selected
  target.setAttribute("aria-selected", true);

  // Hide all tab panels
  grandparent
    .querySelectorAll('[role="tabpanel"]')
    .forEach(p =&gt; p.setAttribute("hidden", true));

  // Show the selected panel
  grandparent.parentNode
    .querySelector(`#${target.getAttribute("aria-controls")}`)
    .removeAttribute("hidden");
}</pre>

<p>{{EmbedLiveSample("Example", 600, 130)}}</p>

<h2 id="Best_practices">Best practices</h2>

<p>It is recommended to use a <code>button</code> element with the role <code>tab</code> for their built-in functional and accessible features instead, as opposed to needing to add them yourself. For controlling tab key functionality for elements with the role <code>tab</code>, it is recommended to set all non-active elements to <code>tabindex=-1</code>, and to set the active element to <code>tabindex=0</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
		</tr>
		<tr>
			<td>{{SpecName("ARIA","#tab","tab")}}</td>
			<td>{{Spec2('ARIA')}}</td>
		</tr>
		<tr>
			<td>{{SpecName("ARIA Authoring Practices","#tabpanel","tabs")}}</td>
			<td>{{Spec2('ARIA Authoring Practices')}}</td>
		</tr>
	</tbody>
</table>

<h2 id="Precedence_order">Precedence order</h2>

<p>What are the related properties, and in what order will this attribute or property be read (which property will take precendence over this one, and which property will be overwritten.</p>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>
